stages: 
  - test
  - stable

image: docker:latest

services:
  - docker:dind

before_script:
  - docker info

build latest image:
  stage: test
  only:
    - main
  script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker info
    - docker build --pull -t "${CI_REGISTRY_IMAGE}:latest" .
    - docker push "${CI_REGISTRY_IMAGE}:latest"

build tagged/stable image:
  stage: stable
  only:
    - tags
  script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker info
    - docker build --pull -t "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}" -t "${CI_REGISTRY_IMAGE}:stable" .
    - docker push "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}"
    - docker push "${CI_REGISTRY_IMAGE}:stable"